=== debian/changelog ===
dmtcp (1.2.5-1ubuntu2) raring; urgency=low

  * Added missing preprocessor directives to fix FTBFS.

 -- Daniel T Chen <crimsun@ubuntu.com>  Tue, 16 Apr 2013 13:20:21 -0400

dmtcp (1.2.5-1ubuntu1) quantal; urgency=low

  * Stop hardcoding the ARM arch and trust GCC's defaults.
  * Allow the packages to build on armhf as well as armel.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 13 Jul 2012 16:26:58 -0600

dmtcp (1.2.5-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.5.
  * debhelper version changed from >=9 to >=7 to accommodate older distros.
  * Standards version changed to 3.9.3. 
  * configure command line updated to include dkpg-buildflags.
  * Added lintian overrides for libmtcp1, dmtcp and libdmtcpaware1 to suppress
    hardening false positives.
  * ARM support added.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 26 May 2012 22:54:33 -0400
