=== debian/control ===
Source: dmtcp
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kapil Arya <kapil@ccs.neu.edu>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7), python
Standards-Version: 3.9.3
Vcs-svn: https://dmtcp.svn.sourceforge.net/svnroot/dmtcp
Vcs-browser: http://dmtcp.svn.sourceforge.net/viewvc/dmtcp/trunk
Homepage: http://dmtcp.sourceforge.net

Package: dmtcp
Architecture: i386 amd64 armel armhf
Depends: libmtcp1, ${shlibs:Depends}, ${misc:Depends}
Description: Checkpoint/Restart functionality for Linux processes
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Window applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package contains DMTCP binaries.

Package: dmtcp-dbg
Architecture: i386 amd64 armel armhf
Section: debug
Priority: extra
Depends: dmtcp, ${misc:Depends}
Description: Debug package for dmtcp
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Window applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package contains debugging symbols for DMTCP.

Package: libmtcp1
Architecture: i386 amd64 armel armhf
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DMTCP library needed for checkpointing a standalone process
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Window applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides libmtcp which is needed by DMTCP to checkpoint a single
 standalone process.

Package: libmtcp-dev
Architecture: i386 amd64 armel armhf
Section: libdevel
Depends: libmtcp1 (= ${binary:Version}), ${misc:Depends}
Description: Developer package for libmtcp
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Window applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides header files needed for building programs with libmtcp.

Package: libdmtcpaware1
Architecture: i386 amd64 armel armhf
Section: libs
Depends: dmtcp, ${shlibs:Depends}, ${misc:Depends}
Description: DMTCP programming interface
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Window applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides a programming interface to allow checkpointed
 applications to interact with dmtcp.

Package: libdmtcpaware-dev
Architecture: i386 amd64 armel armhf
Section: libdevel
Depends: libdmtcpaware1 (= ${binary:Version}), ${misc:Depends}
Description: DMTCP programming interface -- developer package
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Window applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides libraries for developing applications that need to
 interact with dmtcp.
